/*  defs.h

    Common definitions for pointer size and calling conventions.

    Copyright (c) 1991, 1992 by Borland International
    All Rights Reserved.
*/

#ifndef _DEFS_H
#define _DEFS_H

#  define _PTRDEF(name) typedef name * P##name;
#  define _REFDEF(name) typedef name & R##name;
#  define _REFPTRDEF(name) typedef name * & RP##name;
#  define _PTRCONSTDEF(name) typedef const name * PC##name;
#  define _REFCONSTDEF(name) typedef const name & RC##name;

#  define _FPTRDEF(name) typedef name far * P##name;
#  define _FREFDEF(name) typedef name far & R##name;
#  define _FREFPTRDEF(name) typedef name far * far & RP##name;
#  define _FPTRCONSTDEF(name) typedef const name far * PC##name;
#  define _FREFCONSTDEF(name) typedef const name far & RC##name;

#  define _CLASSDEF(name) class name; \
    _PTRDEF(name) \
    _REFDEF(name) \
    _REFPTRDEF(name) \
    _PTRCONSTDEF(name) \
    _REFCONSTDEF(name)
    
#  define _FCLASSDEF(name) class far name; \
    _FPTRDEF(name) \
    _FREFDEF(name) \
    _FREFPTRDEF(name) \
    _FPTRCONSTDEF(name) \
    _FREFCONSTDEF(name)

#endif  /* ___DEFS_H */
